import os, sys
import Tkinter as tk 
import Tkconstants, tkFileDialog
import xmlimport as ximp
import Importfile as fimp
import sqlhandler as sql
import string, shutil
import ttk, vlc, ImageTk




TITLE_FONT = ("Helvetica", 18, "bold")
HEADER_FONT = ("Helvetica", 14, "bold")
class SampleApp(tk.Tk):
    def __init__(self, *args, **kwargs):
        tk.Tk.__init__(self, *args, **kwargs)
        self.title("Mini-MAM")
        print self.cget('bg')
        self.configure(bg='slate gray')

        self.dbpath='data/meta.db'
        self.db=sql.SQLDataBase(self.dbpath)
        upperFrame = tk.Frame(self, bg='black')
        self.playlists=self.db.getPlaylists()
       


        upperFrame.grid(row=0, column=1, sticky="nsew", ipadx=10)
        upperFrame.grid_rowconfigure(0, weight=1)
        upperFrame.grid_columnconfigure(0, weight=1)

        self.buttonFrame = ButtonFrame(upperFrame,self)
        self.buttonFrame.grid(row=0, column=0, sticky="nesw")
        self.buttonFrame.grid_columnconfigure(1, weight=1)

        lowerFrame = tk.Frame(self)
        lowerFrame.grid(row=1, column=1, sticky="nsew", ipadx=10, pady=(0,10))
        lowerFrame.grid_rowconfigure(0, weight=1)
        lowerFrame.grid_columnconfigure(0, weight=1)

        sideFrame = tk.Frame(self)
        sideFrame.grid(row=1, column=0, sticky="nsew",padx=10,pady=10)
        sideFrame.grid_rowconfigure(0, weight=1)
        sideFrame.grid_columnconfigure(0, weight=1)

        self.PlaylistFrame=PlaylistPage(sideFrame,self)
        self.PlaylistFrame.grid(row=0, column=0, sticky="nsew")


        self.frames = {}
        for F in (StartPage,SearchPage, IngestPage, PlayPage):
            frame = F(lowerFrame, self)
            self.frames[F] = frame

            frame.grid(row=0, column=0, sticky="nsew")

        self.show_frame(StartPage)

    def show_frame(self, c,button=None):
        '''Show a frame for the given class'''

        frame = self.frames[c]
        frame.tkraise()
        self.buttonFrame.highlight(button)





class StartPage(tk.Frame):
    def __init__(self, parent, controller,pady=10):
        tk.Frame.__init__(self, parent) 
        label = tk.Label(self, text="Welcome to the Mini-MAM System", font=TITLE_FONT)
        label.pack(side="top", fill="x", pady=10)



class SearchPage(tk.Frame):
    def __init__(self, parent, controller):
        tk.Frame.__init__(self, parent,pady=10) 
        self.mainframe=controller
        self.stringvars={}
        self.stringvars["searchname"]=tk.StringVar()
        self.stringvars["filename"]=tk.StringVar()
        self.stringvars["metaname"]=tk.StringVar()
        self.stringvars["metakeywords"]=tk.StringVar()
        self.stringvars["metamodality"]=tk.StringVar()
        self.stringvars["metadesc"]=tk.StringVar()
        self.stringvars["playlists"]=tk.StringVar()
        self.stringvars["statusbar"]=tk.StringVar()
        self.delPromptOpen=False
        self.currentmeta=None
        self.metalist=None
        self.transPromptOpen=False
        self.expPromptOpen=False

        self.check_positive=ImageTk.PhotoImage(file='data\Resources\check_positive.png')
        self.check_negative=ImageTk.PhotoImage(file='data\Resources\check_negative.png')

        label_search = tk.Label(self,text="Search:")
        label_filler=tk.Label(self)
        label_meta_header = tk.Label(self, text="Metadata", font=HEADER_FONT)
        label_meta_name = tk.Label(self, text="Name:")
        label_meta_modality = tk.Label(self, text="Modality:")
        label_meta_keywords = tk.Label(self, text="Keywords:")
        label_meta_desc = tk.Label(self, text="Description:")
        label_meta_playlist = tk.Label(self, text="Playlists:")
        label_results = tk.Label(self, text='Results:')
        label_playlists=tk.Label(self,textvariable=self.stringvars["playlists"])

        self.statusFrame=tk.Frame(self)
        self.label_status_img=tk.Label(self.statusFrame)
        self.label_status_string=tk.Label(self.statusFrame, textvariable=self.stringvars["statusbar"])

        entry_searchname_var = tk.Entry(self, textvariable=self.stringvars["searchname"])
        button_search = tk.Button(self, text="Search", command=lambda: self.search())
        label_meta_modality_var =tk.Label(self,textvariable=self.stringvars["metamodality"])
        button_x = tk.Button(self, text='X', command=lambda: self.clearIngest())
        entry_name_var = tk.Entry(self, textvariable=self.stringvars["metaname"])
        entry_keywords_var = tk.Entry(self, textvariable=self.stringvars["metakeywords"])
        self.text_desc=tk.Text(self, height=5,width=50)
        button_export = tk.Button(self, text='Export', command=lambda: self.expPrompt())
        button_delete = tk.Button(self, text='Delete', command=lambda: self.delPrompt())
        button_save = tk.Button(self, text='Save', command=lambda: self.save())
        button_addtoplaylist=tk.Button(self, text='Add Item to Playlist', command=lambda: self.addSelectedToPlaylist())
        self.search_menu = tk.Menubutton(self, text ='Browse Results:', relief='raised')





        label_search.grid(row=0, column=0, sticky="sw")
        label_results.grid(row=1, column=0, sticky="sw")
        label_filler.grid(row=2,column=0, columnspan=4)       
        label_meta_header.grid(row=3, column=0, sticky="sw")
        label_meta_name.grid(row=4, column=0, sticky="sw")
        label_meta_modality.grid(row=5, column=0, sticky="sw")
        label_meta_modality_var.grid(row=5, column=1, sticky="sw")
        label_meta_keywords.grid(row=7, column=0, sticky="sw")
        label_meta_desc.grid(row=8, column=0, sticky="sw")
        label_meta_playlist.grid(row=6, column=0, sticky="sw")

        entry_searchname_var.grid(row=0, column=1, sticky="nesw")
        button_search.grid(row=0, column=2, sticky="nesw")
        self.search_menu.grid(row=1, column=1, sticky="news")       
        button_x.grid(row=1, column=2, sticky= "nsw")
        entry_name_var.grid(row = 4, column= 1, sticky="nesw")
        label_playlists.grid(row=6, column=1, sticky="sw")
        entry_keywords_var.grid(row = 7, column= 1, columnspan=3, sticky="nesw")
        self.text_desc.grid(row = 8, column= 1, rowspan=5, columnspan=3, sticky="nesw")
        button_addtoplaylist.grid(row=13, column=1, sticky= "nesw")
        button_export.grid(row=13, column=2, sticky= "nesw")
        button_delete.grid(row=13, column=3, sticky= "nesw")
        button_save.grid(row=14, column=3, sticky= "nesw")
        self.statusFrame.grid(row=14,column=1,columnspan=2,sticky="nesw")
        self.statusFrame.grid_columnconfigure(0,weight=1)
        self.statusFrame.grid_columnconfigure(1,weight=5)
        self.label_status_string.grid(row=0, column=1, sticky="nsw")
        self.label_status_img.grid(row=0, column=0, sticky="nes")


    def search(self):
        self.metalist=self.mainframe.db.searchDatabase(self.stringvars["searchname"].get(),name=True,modality=False,desc=True,keys=True)
        print "Found:"
        for item in self.metalist:

            print item.file_name
        self.buildSearchMenu()
        


    def buildSearchMenu(self):
        self.search_menu.menu= tk.Menu(self.search_menu, tearoff= 0)
        self.search_menu["menu"]=self.search_menu.menu
        for meta in self.metalist:
            self.search_menu.menu.add_command(label=meta.file_name, command=lambda  metavar=meta: self.searchSelect(metavar))
        #self.search_menu.grid(row=1, column=1, sticky="news")

    def searchSelect(self,meta):
        self.clearIngest()
        self.currentmeta=meta
        self.stringvars["metaname"].set(meta.file_name)
        self.stringvars["metakeywords"].set(meta.file_keys)
        self.text_desc.delete('0.0','end')
        self.text_desc.insert('0.0',meta.file_desc)
        self.stringvars["metadesc"].set(meta.file_desc)
        self.stringvars["metamodality"].set(meta.file_type)
        self.getPlaylistsContainingSelected(meta.file_id)


    def clearIngest(self):
        self.text_desc.delete('0.0','end')
        for var in self.stringvars:
            self.stringvars[var].set("")
        if self.metalist==None:
            pass
        else:    
            if self.currentmeta in self.metalist: 
                self.metalist.remove(self.currentmeta)
        self.currentmeta=None
        

    def exportDef(self):
        self.expPromptOpen=False
        if self.top:
            self.top.destroy()

        if self.currentmeta==None:
            print "kake"
        else:
            filename=self.currentmeta.file_name
            filepath=self.currentmeta.file_path
            filext=os.path.splitext(filepath)[1]
            dst=tkFileDialog.asksaveasfilename(initialfile=filename,defaultextension=filext)
            src='data\\'+filepath
            shutil.copyfile(src,dst)

        return
    def exportMXF(self):
        self.expPromptOpen=False
        if self.top:
            self.top.destroy()

        if self.currentmeta==None:
            print "kake"
        elif self.currentmeta.file_type != 'video':
            self.exportDef()
            return 0
        else:
            filename=self.currentmeta.file_name
            filepath=self.currentmeta.file_path
            filext=os.path.splitext(filepath)[1]
            dst=tkFileDialog.asksaveasfilename(initialfile=filename,defaultextension=filext)
            src='data\\'+filepath
            fimp.exportMXF(src,dst)

        return


    def delete(self):
        self.delPromptOpen=False
        self.top.destroy()
        if self.currentmeta==None:
            print "kake"
        else:
            filename=self.mainframe.db.getPath(self.currentmeta.file_id)
            self.mainframe.db.deleteEntry(self.currentmeta)
            self.mainframe.PlaylistFrame.deleteItems(self.currentmeta.file_id)
            self.clearIngest()
            self.buildSearchMenu()
            os.remove(getScriptPath()+"\\data\\"+filename)
            self.updateStatus('delete')
            

    def save(self):
        if self.currentmeta==None:
            print "kake"
        else:
            self.currentmeta.file_desc=self.text_desc.get('0.0','end-1c')
            self.currentmeta.file_keys=self.stringvars["metakeywords"].get()
            self.currentmeta.file_name=self.stringvars["metaname"].get()
            self.mainframe.db.updateEntry(self.currentmeta)
            self.buildSearchMenu()
            self.updateStatus('save')
            self.mainframe.playlists=self.mainframe.db.getPlaylists()
            self.mainframe.PlaylistFrame.refreshTreeFrame()


    def addSelectedToPlaylist(self):
        selectedId=self.mainframe.PlaylistFrame.tree.selection()[0]
        rootlist=self.mainframe.PlaylistFrame.findPlaylist(selectedId,self.mainframe.playlists)
        if rootlist:
            print rootlist.list_id
            key=rootlist.additem(self.currentmeta)
            self.mainframe.db.addItemToPlaylist(rootlist.list_id, self.currentmeta.file_id, key)
            self.mainframe.PlaylistFrame.refreshTreeFrame()
            self.getPlaylistsContainingSelected(self.currentmeta.file_id)

    def transPrompt(self):
        if self.transPromptOpen==False:
            top = self.top = tk.Toplevel(self)
            self.transPromptOpen=True
            self.quality=tk.StringVar()
            self.quality.set('Best')
            self.browsesettings = tk.Menubutton(self, textvaraible=self.quality, relief='raised')
            
    def getPlaylistsContainingSelected(self,entry_id=None):
        self.stringvars["playlists"].set('')
        if entry_id==None:
            if self.currentmeta==None:
                entry_id=None
            else:
                entry_id=self.currentmeta.file_id
        if entry_id:
            playlists=self.mainframe.db.getPlaylistsContaining(entry_id)
            for key in playlists:
                playlist=playlists[key]
                string=self.stringvars["playlists"].get()
                if string=='':
                    string=string+playlist.name
                else:
                    string=string+', '+playlist.name
                self.stringvars["playlists"].set(string)

    def delPrompt(self):
        if self.delPromptOpen==False:
            top = self.top = tk.Toplevel(self)
            self.delPromptOpen=True
            label_sure = tk.Label(top, text='Are you sure you want to delete this file?\n This will remove the file from the Mini-MAM')
            label_sure.grid(row=0, column=0,columnspan=2,sticky='nwse')


            button2 = tk.Button(top, text='Delete', command=lambda: self.delete())
            button2.grid(row=1, column=0,sticky='nesw')

            button3 = tk.Button(top, text='Cancel',
                                    command=lambda: self.promptCancel())
            button3.grid(row=1, column=1,sticky='nesw')

    def expPrompt(self):
        if self.expPromptOpen==False:
            top = self.top = tk.Toplevel(self)
            self.expPromptOpen=True
            label_sure = tk.Label(top, text='Export Normal, or Export MXF?')
            label_sure.grid(row=0, column=0,columnspan=2,sticky='nwse')


            button2 = tk.Button(top, text='Normal', command=lambda: self.exportDef())
            button2.grid(row=1, column=0,sticky='nesw')

            button3 = tk.Button(top, text='XMF',
                                    command=lambda: self.exportMXF())
            button3.grid(row=1, column=1,sticky='nesw')
    
    def promptCancel(self):
        self.delPromptOpen=False
        if self.top:
            self.top.destroy()

    def updateStatus(self,status='clear'):
        print 'ping'
        if status=='clear':
            self.label_status_img.configure(image='')
            self.stringvars["statusbar"].set('')
            self.label_status_img.grid()
        elif status=='save':
            self.label_status_img.configure(image=self.check_positive)
            self.stringvars["statusbar"].set("File saved succesfully!")
            self.label_status_img.grid()
            self.mainframe.after(2000,self.updateStatus)
            #self.statusFrame.grid(row=14,column=1,columnspan=2,sticky="nesw")
        elif status=='no':
            self.label_status_img.configure(image=self.check_negative)
            self.stringvars["statusbar"].set('File uploaded failed!')
            self.mainframe.after(2000,self.updateStatus)
        elif status=='delete':
            self.label_status_img.configure(image=self.check_positive)
            self.stringvars["statusbar"].set("File succesfully removed!")
            self.label_status_img.grid()
            self.mainframe.after(2000,self.updateStatus)




            


class IngestPage(tk.Frame):
    def __init__(self, parent, controller):
        tk.Frame.__init__(self, parent,pady=10)
        self.mainframe=controller
        self.stringvars={}
        self.stringvars["filepath"]=tk.StringVar()
        self.stringvars["filename"]=tk.StringVar()
        self.stringvars["fileext"]=tk.StringVar()
        self.stringvars["metaname"]=tk.StringVar()
        self.stringvars["metamodality"]=tk.StringVar()
        self.stringvars["metakeywords"]=tk.StringVar()
        self.stringvars["metadesc"]=tk.StringVar()
        self.stringvars["playlists"]=tk.StringVar()
        self.stringvars["statusbar"]=tk.StringVar()
        #TEST
        self.stringvars["metamodality"].set("")
        self.playlistbools={}


        self.check_positive=ImageTk.PhotoImage(file='data\Resources\check_positive.png')
        self.check_negative=ImageTk.PhotoImage(file='data\Resources\check_negative.png')
        

        label_open = tk.Label(self, text="Upload File:")
        label_filename = tk.Label(self, text="Name of the file: ")
        label_meta_header = tk.Label(self, text="Metadata", font=HEADER_FONT)
        label_meta_name = tk.Label(self, text="Name:")
        label_meta_modality = tk.Label(self, text="Modality:")
        label_meta_keywords = tk.Label(self, text="Keywords:")
        label_meta_desc = tk.Label(self, text="Description")
        label_playlists = tk.Label(self, text="Add to Playlists:")
        self.label_playlists_list=tk.Label(self,textvariable=self.stringvars['playlists'])
        self.statusFrame=tk.Frame(self)
        self.label_status_img=tk.Label(self.statusFrame)
        self.label_status_string=tk.Label(self.statusFrame, textvariable=self.stringvars["statusbar"])
        label_filler =tk.Label(self)

        button_open = tk.Button(self, text="Select File", command=lambda: self.askopenfilename())
        entry_filename_var = tk.Label(self,bg='SystemDisabledText', textvariable=self.stringvars["filename"],anchor='w')
        entry_name_var = tk.Entry(self, textvariable=self.stringvars["metaname"])
        entry_keywords_var = tk.Entry(self, textvariable=self.stringvars["metakeywords"])
        entry_desc_var = tk.Entry(self, textvariable=self.stringvars["metadesc"])
        label_meta_modality_var = tk.Label(self, textvariable=self.stringvars["metamodality"])
        button_x = tk.Button(self, text='X', command=lambda: self.clear())
        button_openxml = tk.Button(self, text='Import xml metadata', command=lambda: self.importxml())
        button_save = tk.Button(self, text='Save', command=lambda: self.save())
        self.playlist_menu = tk.Menubutton(self, text ='Select playlists', relief='raised')

        self.text_desc=tk.Text(self, height=5,width=50)

        label_open.grid(row=0, column=0, sticky="sw")
        label_filename.grid(row=1, column=0, sticky="sw")
        label_filler.grid(row=2, column=0,columnspan=4)
        label_meta_header.grid(row=3, column=0,  sticky="sw")
        label_meta_name.grid(row=4, column=0, sticky="sw")
        label_meta_modality.grid(row=5, column=0, sticky="sw")
        label_playlists.grid(row=6, column=0, sticky="sw")
        self.label_playlists_list.grid(row=7, column=1, sticky="sw")
        label_meta_keywords.grid(row=8, column=0, sticky="sw")
        label_meta_desc.grid(row=9, column=0, sticky="sw")
        self.statusFrame.grid(row=14,column=1,columnspan=2,sticky="nesw")
        self.statusFrame.grid_columnconfigure(0,weight=1)
        self.statusFrame.grid_columnconfigure(1,weight=5)
        self.label_status_string.grid(row=0, column=1, sticky="nsw")
        self.label_status_img.grid(row=0, column=0, sticky="nes")

        button_open.grid(row =0, column=1, sticky="sw")
        entry_filename_var.grid(row = 1, column= 1, sticky="swe")
        button_x.grid(row=1, column=2, sticky= "nsw")
        button_openxml.grid(row=3, column=1, sticky="sw")
        entry_name_var.grid(row = 4, column= 1, sticky="nesw")
        label_meta_modality_var.grid(row=5, column=1, sticky="sw")
        self.playlist_menu.grid(row=6, column=1, sticky="sw")
        entry_keywords_var.grid(row = 8, column= 1, columnspan=3, sticky="nesw")
        self.text_desc.grid(row = 9, column= 1, rowspan=5, columnspan=3, sticky="nesw")
        button_save.grid(row=14, column=3, sticky= "nsew")



        self.buildPlaylistMenu()
       
        



    def askopenfilename(self):
        self.stringvars["filepath"].set(tkFileDialog.askopenfilename(initialdir=os.getcwd()))
        self.stringvars["filename"].set(os.path.basename(self.stringvars["filepath"].get()))
        self.stringvars["metaname"].set(os.path.basename(self.stringvars["filepath"].get()))
        self.stringvars["fileext"].set(os.path.splitext(self.stringvars["filepath"].get())[1])
        self.stringvars["metamodality"].set(fimp.getFormat(self.stringvars["filepath"].get()))

    def clear(self):
        self.text_desc.delete('0.0','end')
        for var in self.stringvars:
            self.stringvars[var].set("")
        for key in self.playlistbools:
            self.playlistbools[key].set(False)
        self.buildPlaylistMenu()
        self.mainframe.after(2000,self.updateStatus)

    def importxml(self):
        Terms = ximp.Searchterms()
        Terms = ximp.getTerms(tkFileDialog.askopenfilename(initialdir=os.getcwd()))
        self.stringvars["metaname"].set(Terms.file_name)
        self.stringvars["metadesc"].set(Terms.file_desc)
        self.stringvars["metakeywords"].set(", ".join(Terms.file_keys))
        self.text_desc.insert('0.0',Terms.file_desc)

    def save(self):
        entry_id=self.mainframe.db.addEntry(self.stringvars["metaname"].get(),self.stringvars["metamodality"].get(),self.text_desc.get('0.0','end-1c'),self.stringvars["metakeywords"].get())
        srcpath=getScriptPath()+"\\data\\"+"d"+string.zfill(str(entry_id),7)+self.stringvars["fileext"].get()
        dst=fimp.importfile(self.stringvars["filepath"].get(),srcpath)
        self.mainframe.db.setPath(entry_id,dst)
        self.SaveItemtoPlaylists(entry_id)
        self.clear()
        self.updateStatus('yes')
        return

    def buildPlaylistMenu(self):
        self.playlist_menu.menu= tk.Menu(self.playlist_menu, tearoff= 0)
        self.playlist_menu["menu"]=self.playlist_menu.menu


        keylist=self.mainframe.playlists.keys()
        keylist.sort()
        for key in keylist:
            playlist=self.mainframe.playlists[key]
            self.playlistbools[playlist.list_id]=tk.BooleanVar()
            self.playlistbools[playlist.list_id].set(False)
            self.playlistbools[playlist.list_id].trace('w',self.updatePlaylists)
            self.playlist_menu.menu.add_checkbutton(label=playlist.name, onvalue=True, offvalue=False, variable=self.playlistbools[playlist.list_id])
            self.addSubListtoMenu(playlist)
        
        self.playlist_menu.grid(row=6, column=1, sticky="sw")

    def addSubListtoMenu(self,rootlist):
        for playlist in rootlist.playlists.itervalues():
            self.playlistbools[playlist.list_id]=tk.BooleanVar()
            self.playlistbools[playlist.list_id].set(False)
            self.playlistbools[playlist.list_id].trace('w',self.updatePlaylists)
            self.playlist_menu.menu.add_checkbutton(label=playlist.name, onvalue=True, offvalue=False, variable=self.playlistbools[playlist.list_id])
            self.addSubListtoMenu(playlist)

    def SaveItemtoPlaylists(self,entry_id):
        meta=self.mainframe.db.getEntry(entry_id)
        for key in self.playlistbools:
            if self.playlistbools[key].get()==True:
                playlist=self.mainframe.PlaylistFrame.findPlaylist('p'+str(key),self.mainframe.playlists)
                track=playlist.additem(meta)
                self.mainframe.db.addItemToPlaylist(playlist.list_id, meta.file_id, track)
        self.mainframe.PlaylistFrame.refreshTreeFrame()

    def updatePlaylists(self,*args):
        self.stringvars["playlists"].set('')
        string=''
        for list_id in self.playlistbools:
            if self.playlistbools[list_id].get()==True:
                playlist=self.mainframe.PlaylistFrame.findPlaylist('p'+str(list_id),self.mainframe.playlists)
                if string=='':
                    string=string+playlist.name
                else:
                    string=string +', '+playlist.name
        self.stringvars["playlists"].set(string)

    def updateStatus(self,status='clear'):
        print 'ping'
        if status=='clear':
            self.label_status_img.configure(image='')
            self.stringvars["statusbar"].set('')
            self.label_status_img.grid()
            print '1'
        elif status=='yes':
            self.label_status_img.configure(image=self.check_positive)
            self.stringvars["statusbar"].set("File uploaded succesfully!")
            self.label_status_img.grid()
            #self.statusFrame.grid(row=14,column=1,columnspan=2,sticky="nesw")
            print self.stringvars["statusbar"].get()
            print '2'
        elif status=='no':
            self.label_status_img.configure(image=self.check_negative)
            self.stringvars["statusbar"].set('File uploaded failed!')


            





class PlaylistPage(tk.Frame):
    def __init__(self, parent, controller):
        tk.Frame.__init__(self, parent)
        self.mainframe=controller
        self.stringvars={}
        self.namePromptOpen=False
        self.delPromptOpen=False
        self.focus=None
        self.top=None

        self.icon_vid=ImageTk.PhotoImage(file='data\Resources\icon_video.png')
        self.icon_img=ImageTk.PhotoImage(file='data\Resources\icon_img.png')
        self.icon_playlist=ImageTk.PhotoImage(file='data\Resources\icon_playlist.png')
        self.icon_unknown=ImageTk.PhotoImage(file='data\Resources\icon_unknown.png')
        self.icon_music=ImageTk.PhotoImage(file='data\Resources\icon_music.png')
        self.icon_moveup=ImageTk.PhotoImage(file='data\Resources\moveup.png')
        self.icon_movedown=ImageTk.PhotoImage(file='data\Resources\movedown.png')

        button_newlist= tk.Button(self, text="New Playlist",command=lambda: self.namePrompt())
        button_dellist=tk.Button(self,text="Delete", command=lambda: self.delPrompt())
        button_newsublist=tk.Button(self,text="Add Sublist", command=lambda: self.subnamePrompt())
        button_moveup=tk.Button(self,image=self.icon_moveup, command=lambda: self.moveItemUp())
        button_movedown=tk.Button(self,image=self.icon_movedown, command=lambda: self.moveItemDown())

        self.playtreeframe = tk.Frame(self)
        self.createPlayTreeFrame()


        self.playtreeframe.grid(row=2, column=0, rowspan=5, columnspan=5, sticky="nesw")

        button_newlist.grid(row=7,column=0,sticky='nesw')
        button_dellist.grid(row=7,column=2,sticky='nesw') 
        button_newsublist.grid(row=7,column=1,sticky='nesw') 

        button_moveup.grid(row=2,column=6,sticky='esw')
        button_movedown.grid(row=3,column=6,sticky='new')     

    


    def createPlayTreeFrame(self):
        self.tree=ttk.Treeview(self.playtreeframe)
        ysb = ttk.Scrollbar(self.playtreeframe, orient='vertical', command=self.tree.yview)
        xsb = ttk.Scrollbar(self.playtreeframe, orient='horizontal', command=self.tree.xview)
        self.tree.configure(yscroll=ysb.set, xscroll=xsb.set)
        self.tree.heading('#0', text='Playlists', anchor='w')
        self.tree.column('#0',minwidth=700, stretch=True)

        #self.root_node = self.tree.insert('', 'end', text='Playlists:', open=True, iid='root')
        self.populatePlayTreeFrame('',self.mainframe.playlists)
        self.tree.bind("<Double-1>", self.OnDoubleClick)
        self.tree.grid(row=0, column=0)
        ysb.grid(row=0, column=1, sticky='ns')
        xsb.grid(row=1, column=0, sticky='ew')

    def OnDoubleClick(self, event):
        self.focus = self.tree.selection()[0]
        print self.focus
        if self.focus[0]=='i':
            self.mainframe.frames[PlayPage].playItem(self.focus)


    def populatePlayTreeFrame(self,root_node,items):
        if isinstance(items,dict) and len(items)>0:
            keylist=items.keys()
            keylist.sort()
            for key in keylist:
                item=items[key]
                if type(item)==sql.Playlist:
                    play_node = self.tree.insert(root_node, 'end', text=item.name, iid='p'+str(item.list_id), image=self.icon_playlist, open=False)                
                    self.populatePlayTreeFrame(play_node,item.playlists)
                    self.populatePlayTreeFrame(play_node,item.items)
                if type(item)==sql.MetaData:
                    if item.file_type =='video':
                        img=self.icon_vid
                    elif item.file_type =='image':
                        img=self.icon_img
                    elif item.file_type=='audio':
                        img=self.icon_music
                    else:
                        img=self.icon_unknown
                    item_node = self.tree.insert(root_node, 'end', text=item.file_name, iid='i'+str(item.file_id)+str(root_node)+'t'+str(key), image=img, open=False)
    def clearTreeFrame(self):
        to_del = self.tree.get_children()
        for item in to_del:
            self.tree.delete(item)

    def refreshTreeFrame(self):
        self.clearTreeFrame()
        self.populatePlayTreeFrame('',self.mainframe.playlists)
        self.mainframe.frames[IngestPage].buildPlaylistMenu()

    def newPlaylist(self,name):
        self.namePromptOpen=False
        self.top.destroy()
        list_id=self.mainframe.db.addPlaylist(name,False)
        newlist=sql.Playlist(name,list_id)
        self.mainframe.playlists['p'+str(newlist.list_id)]=newlist
        self.refreshTreeFrame()

    def newSubPlaylist(self,name):
        focus=self.tree.selection()[0]
        self.top.destroy()
        if focus[0]!='p':
            self.dispError('No Playlist selected!')
            return 0

        self.namePromptOpen=False
        list_id=self.mainframe.db.addPlaylist(name,True)
        print focus
        newlist=sql.Playlist(name,list_id)
        rootlist=self.findPlaylist(focus,self.mainframe.playlists)
        print rootlist
        if rootlist:
            rootlist.addsublist(newlist)
            self.refreshTreeFrame()
            self.mainframe.db.addSublisttoPlaylist(rootlist.list_id,list_id)

        else:
            print "HALAAAAALALALAAL"
            #self.dispError('Error! Cannot find playlist :'+str(focus))
            self.mainframe.db.deletePlaylist(list_id)

    def moveItemUp(self):
        focus=self.tree.selection()[0]
        iid=focus
        [item_id, rest]=focus.split('p')
        [list_id, track]=rest.split('t')
        print item_id,list_id,track
        rootlist=self.findPlaylist('p'+list_id,self.mainframe.playlists)
        if rootlist:
            if int(track)>1 and int(track)<rootlist.items:
                pos=track
                newpos=str(int(track)-1)
                print pos
                print newpos
                temp=rootlist.items[pos]
                rootlist.items[pos]=rootlist.items[newpos]
                rootlist.items[newpos]=temp

                iid2='i'+str(rootlist.items[pos].file_id)+str('p'+list_id)+'t'+str(newpos)

                print iid
                print iid2

                self.mainframe.db.editPlaylistTrackPos(rootlist.list_id,rootlist.items[newpos].file_id,pos,rootlist.items[pos].file_id,newpos)

                self.tree.delete(iid,iid2)
                self.insertNode(rootlist.items[pos],'p'+list_id,int(pos))
                self.insertNode(rootlist.items[newpos],'p'+list_id,int(newpos))
                

    def moveItemDown(self):
        focus=self.tree.selection()[0]
        iid=focus
        [item_id, rest]=focus.split('p')
        [list_id, track]=rest.split('t')
        print item_id,list_id,track
        rootlist=self.findPlaylist('p'+list_id,self.mainframe.playlists)
        if rootlist:
            if int(track)>=1 and int(track)<rootlist.items:
                pos=track
                newpos=str(int(track)+1)
                print pos
                print newpos
                temp=rootlist.items[pos]
                rootlist.items[pos]=rootlist.items[newpos]
                rootlist.items[newpos]=temp

                iid2='i'+str(rootlist.items[pos].file_id)+str('p'+list_id)+'t'+str(newpos)

                print iid
                print iid2

                self.mainframe.db.editPlaylistTrackPos(rootlist.list_id,rootlist.items[newpos].file_id,pos,rootlist.items[pos].file_id,newpos)

                self.tree.delete(iid,iid2)
                self.insertNode(rootlist.items[pos],'p'+list_id,int(pos))
                self.insertNode(rootlist.items[newpos],'p'+list_id,int(newpos))
                

                

    def insertNode(self,item,parent,index):

        if item.file_type =='video':
            img=self.icon_vid
        elif item.file_type =='image':
            img=self.icon_img
        elif item.file_type=='audio':
            img=self.icon_music
        else:
            img=self.icon_unknown

        self.tree.insert(parent, int(index-1), text=item.file_name, iid='i'+str(item.file_id)+str(parent)+'t'+str(index), image=img, open=False)
                


    def deleteItem(self,item):
        focus=item
        if self.delPromptOpen:
            self.delPromptOpen=False
            self.top.destroy()
        [item_id, rest]=focus.split('p')
        [list_id, track]=rest.split('t')
        print item_id,list_id,track
        rootlist=self.findPlaylist('p'+list_id,self.mainframe.playlists)
        if rootlist:
            self.mainframe.db.removeItemFromPlaylist(rootlist.list_id,rootlist.items[track].file_id,track)
            rootlist.delitem(track)

        self.refreshTreeFrame()
        self.mainframe.frames[SearchPage].getPlaylistsContainingSelected()

    def deleteItems(self,item_id):
        ListStack=[]
        for items in self.mainframe.playlists:
            ListStack.append(self.mainframe.playlists[items])
        print ListStack
        while ListStack:
            CurrList=ListStack.pop()
            todel=[]
            for key in CurrList.items:
                if key=='0':
                    pass
                elif CurrList.items[key].file_id==item_id:
                    self.mainframe.db.removeItemFromPlaylist(CurrList.list_id,CurrList.items[key].file_id,key)
                    todel.append(key)
            for key in todel:
                CurrList.delitem(key)
        self.refreshTreeFrame()

          


    

    def deletePlaylist(self,focus):
        print focus
        if self.delPromptOpen:
            self.delPromptOpen=False
            self.top.destroy()
        listtodel=self.findPlaylist(focus,self.mainframe.playlists)
        #rootlist=self.findPlaylist('p'+str(listtodel.parent_id),self.mainframe.playlists)

        print listtodel.parent_id
        delete_stack=[listtodel]
        while delete_stack:
            curr_list=delete_stack.pop()
            for item in curr_list.playlists:
                delete_stack.append(curr_list.playlists[item])
            self.mainframe.db.deletePlaylist(curr_list.list_id)
        self.mainframe.playlists=[]
        self.mainframe.playlists=self.mainframe.db.getPlaylists()
        self.refreshTreeFrame()


    
    def findPlaylist(self,list_id,dictionary):
        stack=[dictionary]
        while stack:
            curr_dict=stack.pop()
            curr_dict.keys()
            if list_id in curr_dict.keys():
                return curr_dict[list_id]
            else:
                for key in curr_dict:
                    if isinstance(curr_dict[key],sql.Playlist):
                        stack.append(curr_dict[key].playlists)





    def deleteSelect(self):
        focus=self.tree.selection()[0]
        if focus[0]=='i':
            self.deleteItem(focus)
        elif focus[0]=='p':
            self.deletePlaylist(focus)

  

    def namePrompt(self):
        print self.delPromptOpen
        print self.namePromptOpen
        print self.top
        if self.delPromptOpen==False and self.namePromptOpen==False:
            top = self.top = tk.Toplevel(self)
            self.namePromptOpen=True
            label_name = tk.Label(top, text='Name: ')
            label_name.grid(row=0, column=0,sticky='nw')

            self.entry0 = tk.Entry(top)
            self.entry0.grid(row=0, column=1,sticky='ne')

            button2 = tk.Button(top, text='Submit', command=lambda: self.newPlaylist(self.entry0.get()))
            button2.grid(row=1, column=0,sticky='sw')

            button3 = tk.Button(top, text='Cancel',
                                    command=lambda: self.promptCancel())
            button3.grid(row=1, column=1,sticky='se')

    def subnamePrompt(self):
        if self.delPromptOpen==False and self.namePromptOpen==False:
            top = self.top = tk.Toplevel(self)
            self.namePromptOpen=True
            label_name = tk.Label(top, text='Name: ')
            label_name.grid(row=0, column=0,sticky='nw')

            self.entry0 = tk.Entry(top)
            self.entry0.grid(row=0, column=1,sticky='ne')

            button2 = tk.Button(top, text='Submit', command=lambda: self.newSubPlaylist(self.entry0.get()))
            button2.grid(row=1, column=0,sticky='sw')

            button3 = tk.Button(top, text='Cancel',
                                    command=lambda: self.promptCancel())
            button3.grid(row=1, column=1,sticky='se')
    def delPrompt(self):
        if self.delPromptOpen==False and self.namePromptOpen==False:
            top = self.top = tk.Toplevel(self)
            self.delPromptOpen=True
            label_sure = tk.Label(top, text='Are you sure? ')
            label_sure.grid(row=0, column=0,columnspan=2,sticky='nwse')


            button2 = tk.Button(top, text='Delete', command=lambda: self.deleteSelect())
            button2.grid(row=1, column=0,sticky='sw')

            button3 = tk.Button(top, text='Cancel',
                                    command=lambda: self.promptCancel())
            button3.grid(row=1,column=1,sticky='se')

    def promptCancel(self):
        self.delPromptOpen=False
        self.namePromptOpen=False
        if self.top:
            self.top.destroy()








class PlayPage(tk.Frame):
    def __init__(self, parent, controller):
        tk.Frame.__init__(self, parent,pady=10)

        self.mainframe=controller
        self.scalevar=tk.DoubleVar()

        self.playthumb=ImageTk.PhotoImage(file='data\Resources\play.png')
        self.pausethumb=ImageTk.PhotoImage(file='data\Resources\pause.png')
        self.stopthumb=ImageTk.PhotoImage(file='data\Resources\stop.png')
        self.nextthumb=ImageTk.PhotoImage(file='data\Resources\\next.png')
        self.prevthumb=ImageTk.PhotoImage(file='data\Resources\prev.png')



        self.instance=vlc.Instance()
        self.mediaplayer=self.instance.media_player_new()
        self.medialistplayer=self.instance.media_list_player_new()

        self.mediaframe=tk.Canvas(self,bg='black')       

        self.controlframe=tk.Frame(self)

        self.vidscale=ttk.Scale(self, orient=tk.HORIZONTAL,variable=self.scalevar, to=1000, command=self.setPosition)

        self.playbutton=tk.Button(self.controlframe, image=self.playthumb, command=lambda: self.PlayPause())
        self.stopbutton=tk.Button(self.controlframe, image=self.stopthumb, command=lambda: self.Stop())
        self.prevbutton=tk.Button(self.controlframe, image=self.prevthumb, command=lambda: self.Prev())
        self.nextbutton=tk.Button(self.controlframe, image=self.nextthumb, command=lambda: self.Next())



        self.controlframe.grid(row=11,column=0,columnspan=10,sticky='nesw')
        self.vidscale.grid(row=10,column=0,columnspan=10,sticky='nesw')
        self.playbutton.grid(row=1,column=0,sticky='nesw')
        self.prevbutton.grid(row=1,column=3,sticky='nsw')
        self.stopbutton.grid(row=1,column=4,sticky='nsw')
        self.nextbutton.grid(row=1,column=5,sticky='nsw')
        self.mediaframe.grid(row=0,column=0,columnspan=10,rowspan=10,sticky='nesw')



    def playItem(self,focus):
        [item_id, rest]=focus.split('p')
        [list_id, track]=rest.split('t')
        print track
        rootlist=self.mainframe.PlaylistFrame.findPlaylist('p'+list_id,self.mainframe.playlists)
        if rootlist:
            print rootlist.items
            self.media = self.instance.media_new(unicode('data\\')+unicode(rootlist.items[track].file_path))
            self.mediaplayer.set_media(self.media)
            self.media.parse()
            if sys.platform == "linux2": # for Linux using the X Server
                self.mediaplayer.set_xwindow(self.mediaframe.winfo_id())
            elif sys.platform == "win32": # for Windows
                self.mediaplayer.set_hwnd(self.mediaframe.winfo_id())
            elif sys.platform == "darwin": # for MacOS
                self.mediaplayer.set_nsobject(self.mediaframe.winfo_id())
            self.mainframe.show_frame(PlayPage)
            self.Stop()
            self.PlayPause()







    def getFile(self):
        selectedId=self.mainframe.PlaylistFrame.tree.selection()[0]
        print selectedId
        rootlist=self.mainframe.PlaylistFrame.findPlaylist(selectedId,self.mainframe.playlists)
        if rootlist:
            self.currentlist=self.instance.media_list_new()
            keylist = rootlist.items.keys()
            keylist.sort()
            for key in keylist:
                if key != '0':
                    self.media = self.instance.media_new(unicode('data\\')+unicode(rootlist.items[key].file_path))
                    self.currentlist.insert_media(self.media,int(key)-1)
            self.medialistplayer.set_media_list(self.currentlist)
            self.medialistplayer.set_media_player(self.mediaplayer)
            if sys.platform == "linux2": # for Linux using the X Server
                self.mediaplayer.set_xwindow(self.mediaframe.winfo_id())
            elif sys.platform == "win32": # for Windows
                self.mediaplayer.set_hwnd(self.mediaframe.winfo_id())
            elif sys.platform == "darwin": # for MacOS
                self.mediaplayer.set_nsobject(self.mediaframe.winfo_id())
            self.medialistplayer.play()
            self.updateTrigger()





    def OpenFile(self, filename=None):
        """Open a media file in a MediaPlayer
        """
        if filename is None:
            filename = tkFileDialog.askopenfilename(initialdir='C:\\')
        if not filename:
            return
        # create the media
        self.media = self.instance.media_new(unicode(filename))
        # put the media in the media player
        self.mediaplayer.set_media(self.media)
        # parse the metadata of the file
        self.media.parse()
        # set the title of the track as window title
        #self.setWindowTitle(self.media.get_meta(0))
        # the media player has to be 'connected' to the QFrame
        # (otherwise a video would be displayed in it's own window)
        # this is platform specific!
        # you have to give the id of the QFrame (or similar object) to
        # vlc, different platforms have different functions for this
        if sys.platform == "linux2": # for Linux using the X Server
            self.mediaplayer.set_xwindow(self.mediaframe.winfo_id())
        elif sys.platform == "win32": # for Windows
            self.mediaplayer.set_hwnd(self.mediaframe.winfo_id())
        elif sys.platform == "darwin": # for MacOS
            self.mediaplayer.set_nsobject(self.mediaframe.winfo_id())
        self.PlayPause()


    def Stop(self):
        self.mediaplayer.stop()
        self.playbutton.configure(image=self.playthumb)


    def PlayPause(self):
        if self.mediaplayer.is_playing():
            self.mediaplayer.pause()
            self.playbutton.configure(image=self.playthumb)
            self.isPaused = True
        else:
            if self.mediaplayer.play() == -1:
                self.getFile()
                
                #self.OpenFile()
                return
            self.mediaplayer.play()
            self.playbutton.configure(image=self.pausethumb)
            self.updateTrigger()
            self.isPaused = False

    def Prev(self):
        self.medialistplayer.previous()
        self.updateTrigger()

    def Next(self):
        self.medialistplayer.next()
        self.updateTrigger()

    def setPosition(self,Pos=None):
        self.mediaplayer.set_position(self.vidscale.get()/1000.0)

    def updateTrigger(self):
        self.mainframe.after(200,self.updateUI)

    def updateUI(self):
        self.scalevar.set((self.mediaplayer.get_position()*1000))
        if self.mediaplayer.is_playing():
            self.mainframe.after(100,self.updateUI)



class ButtonFrame(tk.Frame):
    def __init__(self, parent, controller):
        tk.Frame.__init__(self, parent)
        self.searchbutton = tk.Button(self, text="Search", 
                           command=lambda: controller.show_frame(SearchPage,self.searchbutton))
        self.searchbutton.grid(row=0,column=1,sticky="nsew")
        self.grid_columnconfigure(1, weight=1)
        

        self.ingestbutton = tk.Button(self, text="Ingest", 
                           command=lambda: controller.show_frame(IngestPage,self.ingestbutton))
        self.ingestbutton.grid(row=0,column=0,sticky="nsew")

        self.playbutton = tk.Button(self, text="Play", 
                           command=lambda: controller.show_frame(PlayPage,self.playbutton))
        self.playbutton.grid(row=0,column=2,sticky="nsew") 
        

        self.grid_columnconfigure(0, weight=1)
        self.grid_columnconfigure(1, weight=1)
        self.grid_columnconfigure(2, weight=1)
        self.grid_rowconfigure(0,weight=1)
        self.buttonlist=[self.ingestbutton, self.playbutton, self.searchbutton]

    def highlight(self,curbutton):
        for button in self.buttonlist:
            button.configure(bg='slate gray')
        if curbutton:
            curbutton.configure(bg='SystemButtonFace')



def getScriptPath():
    return os.path.dirname(os.path.realpath(sys.argv[0]))


if __name__ == "__main__":
    app = SampleApp()
    app.mainloop()