import sqlite3

class MetaData(object):
    def __init__(self,file_id=None,file_name=None,file_path=None,file_type=None,file_desc=None,file_keys=None):
        self.file_id=file_id
        self.file_type=file_type
        self.file_name=file_name
        self.file_path=file_path
        self.file_desc=file_desc
        self.file_keys=file_keys

class Playlist(object):
    def __init__(self,name,list_id,sub=False,parent_id=0):
    	self.parent_id=parent_id
        self.list_id=list_id
        self.name=name
        self.items={}
        self.playlists={}
        self.items['0']='Nothing'
        if self.list_id==0:
            print 'Cannot Create Playlist'
            self.name='INVALID'
    def insertItem(self,item,pos):
    	if  type(item)==MetaData:

            self.items[str(pos)]=item

        else:
            print "Invalid target"


    def additem(self,item): #assume item to be of type MetaData
        if  type(item)==MetaData:
            key=len(self.items)
            self.items[str(key)]=item
            return key

        else:
            print "Invalid target"
            return None
    def addsublist(self,sublist):
    	if type(sublist==Playlist):
    		self.playlists['p'+str(sublist.list_id)]=sublist
    		sublist.parent_id=self.list_id
    	else:
    		print 'error in addsublist'

    def delitem(self,track):
    	del self.items[track]
    	for key in self.items.keys():
    		if int(key)>int(track):
    			var=int(key)-1
    			self.items[str(var)]=self.items[key]
    			del self.items[key]



class SQLDataBase(object):


	def __init__(self,path):
		self.path=path
		self.db=None
		try:
			print path
			self.db=sqlite3.connect(path)
			self.cursor=self.db.cursor()

			self.cursor.execute('''CREATE TABLE IF NOT EXISTS metadata(id INTEGER PRIMARY KEY, name TEXT, filepath TEXT, modality TEXT, description TEXT , keywords TEXT)''')
			self.cursor.execute('''CREATE TABLE IF NOT EXISTS tPlaylist(playlistId INTEGER PRIMARY KEY, name TEXT, sub BOOLEAN)''')
			self.cursor.execute('''CREATE TABLE IF NOT EXISTS tPlaylistPlaylistMap(mapId INTEGER PRIMARY KEY, rootId INTEGER , subId INTEGER,
				 FOREIGN KEY (rootId) 
				 	REFERENCES tPlaylist (playlistId)
				 	ON DELETE CASCADE
				 FOREIGN KEY (subId) 
				 	REFERENCES tPlaylist (playlistId)
				 	ON DELETE CASCADE 
				 	); ''')
			self.cursor.execute('''CREATE TABLE IF NOT EXISTS tPlaylistItemMap (mapId INTEGER PRIMARY KEY, playlistId INTEGER,
				metaId INTEGER , trackNumber INTEGER,
				FOREIGN KEY (playlistId) 
					REFERENCES tPlaylist (playlistId)
				FOREIGN KEY (metaId) 
					REFERENCES metadata (id)
				UNIQUE (playlistId, metaId, trackNumber) 
				);''')

			self.db.commit()
		

		# Catch the exception
		except Exception as e:
		    print e
		    # Roll back any change if something goes wrong
		    self.db.rollback()

		    #raise e
		finally:
		    # Close the db connection
		    self.db.close()

	def addEntry(self,name,modality="",description="",keywords=""):
		entry_id=0
		filepath=''
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()

			self.cursor.execute('''INSERT INTO metadata(name, filepath, modality, description, keywords)
                  VALUES(?,?,?,?,?)''', (name, filepath, modality, description, keywords))
			entry_id=self.cursor.lastrowid
			self.db.commit()

		# Catch the exception
		except Exception as e:
		    # Roll back any change if something goes wrong
		    self.db.rollback()
		    entry_id=0
		    raise e
		finally:
		    # Close the db connection
		    self.db.close()
		return entry_id

	def getEntry(self,entry_id):
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()

			self.cursor.execute('''SELECT * from metadata WHERE id=?''', (entry_id,))
			item=self.cursor.fetchone()
			metadata=MetaData(file_id=item[0],file_name=item[1],file_path=item[2],file_type=item[3],file_desc=item[4],file_keys=item[5])
			

		# Catch the exception
		except Exception as e:
		    # Roll back any change if something goes wrong
		    self.db.rollback()
		    
		    raise e
		finally:
		    # Close the db connection
		    self.db.close()
		return metadata




	def setPath(self,entry_id,filepath):
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()

			self.cursor.execute('''UPDATE metadata SET filepath=? WHERE id=?''', (filepath,entry_id))
			entry_id=self.cursor.lastrowid
			self.db.commit()

		# Catch the exception
		except Exception as e:
		    # Roll back any change if something goes wrong
		    self.db.rollback()
		    entry_id=0
		    raise e
		finally:
		    # Close the db connection
		    self.db.close()
		return entry_id

	def getPath(self,entry_id):
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()

			self.cursor.execute('''SELECT filepath from metadata WHERE id=?''', (entry_id,))
			path=self.cursor.fetchone()

		# Catch the exception
		except Exception as e:
		    # Roll back any change if something goes wrong
		    
		    raise e
		finally:
		    # Close the db connection
		    self.db.close()
		return str(path[0])


	def searchDatabase(self,term,name=False,modality=False,desc=False,keys=False):
		metalist=[]
		idlist=[]
		term='%' + term + '%'

		print term
		
		self.db=sqlite3.connect(self.path)
		self.cursor=self.db.cursor()

		if name==True:
			self.cursor.execute('''SELECT * FROM metadata WHERE name LIKE ?''', (term,))
			for item in self.cursor.fetchall():
				metadata=MetaData(file_id=item[0],file_name=item[1],file_path=item[2],file_type=item[3],file_desc=item[4],file_keys=item[5])
				if not metadata.file_id in idlist:
					metalist.append(metadata)
					idlist.append(metadata.file_id)
					print metadata.file_name
		
		if modality==True:
			self.cursor.execute('''SELECT * FROM metadata WHERE modality LIKE ?''', (term,))

			for item in self.cursor.fetchall():
				metadata=MetaData(file_id=item[0],file_name=item[1],file_path=item[2],file_type=item[3],file_desc=item[4],file_keys=item[5])
				if not metadata.file_id in idlist:
					metalist.append(metadata)
					idlist.append(metadata.file_id)
					print metadata.file_name
			
		if desc==True:
			self.cursor.execute('''SELECT * FROM metadata WHERE description LIKE ?''', (term,))

			for item in self.cursor.fetchall():
				metadata=MetaData(file_id=item[0],file_name=item[1],file_path=item[2],file_type=item[3],file_desc=item[4],file_keys=item[5])
				if not metadata.file_id in idlist:
					metalist.append(metadata)
					idlist.append(metadata.file_id)
					print metadata.file_name
			
		if keys==True:
			self.cursor.execute('''SELECT * FROM metadata WHERE keywords LIKE ?''', (term,))

			for item in self.cursor.fetchall():
				metadata=MetaData(file_id=item[0],file_name=item[1],file_path=item[2],file_type=item[3],file_desc=item[4],file_keys=item[5])
				if not metadata.file_id in idlist:
					metalist.append(metadata)
					idlist.append(metadata.file_id)
					print metadata.file_name


		self.db.close()
		return metalist





	def updateEntry(self, metadata): #Takes input of type MetaData
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()
			self.cursor.execute('''UPDATE metadata SET name=?, description=?, keywords=? WHERE id=?''', (metadata.file_name , metadata.file_desc, metadata.file_keys, metadata.file_id))
			self.db.commit()

		except Exception as e:
			    # Roll back any change if something goes wrong
			self.db.rollback()
			raise e

		finally:
			    # Close the db connection
			self.db.close()

	def deleteEntry(self, metadata):
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()
			self.cursor.execute('''SELECT * from tPlaylistItemMap where metaId=? ''',(metadata.file_id,))
			DBMaplist=self.cursor.fetchall() #,mapid,list,meta,track
			for DBMap in DBMaplist:
				self.removeItemFromPlaylist(DBMap[2],DBMap[1],DBMap[3]) #meta #list #track
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()
			self.cursor.execute('''DELETE from metadata where id=? ''', (metadata.file_id ,))
			self.db.commit()

		except Exception as e:
			    # Roll back any change if something goes wrong
			self.db.rollback()
			raise e

		finally:
			    # Close the db connection
			self.db.close()

	def addPlaylist(self,name,sub):
		entry_id=0
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()

			self.cursor.execute('''INSERT INTO tPlaylist(name, sub)
                  VALUES(?,?)''', (name, sub))
			entry_id=self.cursor.lastrowid
			self.db.commit()

		# Catch the exception
		except Exception as e:
		    # Roll back any change if something goes wrong
		    self.db.rollback()
		    entry_id=0
		    raise e
		finally:
		    # Close the db connection
		    self.db.close()
		return entry_id

	def addItemToPlaylist(self,PlaylistId,MetadataId,track):
		entry_id=0
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()

			self.cursor.execute('''INSERT INTO tPlaylistItemMap(playlistId, metaId, trackNumber)
                  VALUES(?,?,?)''', (PlaylistId, MetadataId,track))
			entry_id=self.cursor.lastrowid
			self.db.commit()

		# Catch the exception
		except Exception as e:
		    # Roll back any change if something goes wrong
		    self.db.rollback()
		    entry_id=0
		    raise e
		finally:
		    # Close the db connection
		    self.db.close()
		return entry_id

	def editPlaylistTrackPos(self,playlistId,MetadataId1,track1, MetadataId2,track2):
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()
			self.cursor.execute('''UPDATE tPlaylistItemMap SET trackNumber=? WHERE playlistId=? AND metaId=?''', (track2, playlistId, MetadataId1))
			self.cursor.execute('''UPDATE tPlaylistItemMap SET trackNumber=? WHERE playlistId=? AND metaId=?''', (track1, playlistId, MetadataId2))
			self.db.commit()

		except Exception as e:
			    # Roll back any change if something goes wrong
			self.db.rollback()
			raise e

		finally:
			    # Close the db connection
			self.db.close()
	def getPlaylistsContaining(self,entry_id):
		lists={}
		self.db=sqlite3.connect(self.path)
		self.cursor=self.db.cursor()
		self.cursor.execute('''SELECT playlistId FROM tPlaylistItemMap WHERE metaId=?''',(entry_id,))
		DBIDLists=self.cursor.fetchall()
		for listid in DBIDLists:
			self.cursor.execute('''SELECT * FROM tPlaylist WHERE playlistId=?''',(listid[0],))
			DBLists=self.cursor.fetchall()
			for DBList in DBLists:
				playlist=Playlist(DBList[1],DBList[0])
				sublists=self.getSubPlaylists(playlist.list_id)
				for sublist in sublists:
					playlist.addsublist(sublist)
				items=self.getPlaylistItems(playlist.list_id)
				#print items.keys()
				for key in items.keys():
					playlist.insertItem(items[key],key)
				lists['p'+str(playlist.list_id)]=playlist		
		return lists


	def getPlaylists(self):
		test=False
		lists={}
		self.db=sqlite3.connect(self.path)
		self.cursor=self.db.cursor()
		self.cursor.execute('''SELECT * FROM tPlaylist WHERE sub=?''',(test,))
		DBLists=self.cursor.fetchall()
		for DBList in DBLists:
			playlist=Playlist(DBList[1],DBList[0])
			sublists=self.getSubPlaylists(playlist.list_id)
			for sublist in sublists:
				playlist.addsublist(sublist)
			items=self.getPlaylistItems(playlist.list_id)
			#print items.keys()
			for key in items.keys():
				playlist.insertItem(items[key],key)
			lists['p'+str(playlist.list_id)]=playlist


			
		return lists

	def getSubPlaylists(self,list_id):
		retlist=[]
		self.db=sqlite3.connect(self.path)
		self.cursor=self.db.cursor()

		self.cursor.execute('''SELECT subId FROM tPlaylistPlaylistMap WHERE rootId=?''',(list_id,))
		DBSubLists=self.cursor.fetchall()
		for DBSubList in DBSubLists:
			self.cursor.execute('''SELECT * FROM tPlaylist WHERE playlistId=?''',(DBSubList[0],))
			DBList=self.cursor.fetchall()
			if DBList:
				playlist=Playlist(DBList[0][1],DBList[0][0],sub=True)
				sublists=self.getSubPlaylists(playlist.list_id)
				for sublist in sublists:
					playlist.addsublist(sublist)
				items=self.getPlaylistItems(playlist.list_id)
				for key in items.keys():
					playlist.insertItem(items[key],key)
				retlist.append(playlist)

		return retlist

	def getPlaylistItems(self, list_id):
		items={}
		self.db=sqlite3.connect(self.path)
		self.cursor=self.db.cursor()
		self.cursor.execute('''SELECT metaId, trackNumber FROM tPlaylistItemMap WHERE playlistId=?''',(list_id,))
		DBItemList=self.cursor.fetchall()

		for DBItem in DBItemList:
			self.cursor.execute('''SELECT * FROM metadata WHERE id=?''',(DBItem[0],))
			item=self.cursor.fetchall()
			item=item[0]
			meta=MetaData(file_id=item[0],file_name=item[1],file_path=item[2],file_type=item[3],file_desc=item[4],file_keys=item[5])
			items[str(DBItem[1])]=meta
		
		return items

	def deletePlaylist(self,list_id):
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()
			self.cursor.execute('''DELETE from tPlaylistItemMap WHERE playlistId=?''',(list_id,))
			self.cursor.execute('''DELETE from tPlaylistPlaylistMap WHERE rootId=?''',(list_id,))
			self.cursor.execute('''DELETE from tPlaylist WHERE playlistId=?''',(list_id,))
			self.db.commit()

		except Exception as e:
			    # Roll back any change if something goes wrong
			self.db.rollback()
			raise e
		finally:
			self.db.close()



	def removeItemFromPlaylist(self,list_id,itemId,track):
		try:
			track=int(track)
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()
			self.cursor.execute('''DELETE from tPlaylistItemMap WHERE playlistId=? AND metaId=? AND trackNumber=?''',(list_id, itemId, track))
			self.cursor.execute('''UPDATE tPlaylistItemMap SET trackNumber=trackNumber-1 WHERE playlistId=? AND trackNumber>?''',(list_id, track))

			self.db.commit()

		except Exception as e:
			    # Roll back any change if something goes wrong
			self.db.rollback()
			raise e

		finally:
			    # Close the db connection
			self.db.close()



	def addSublisttoPlaylist(self,rootId,subId):
		entry_id=0
		try:
			self.db=sqlite3.connect(self.path)
			self.cursor=self.db.cursor()

			self.cursor.execute('''INSERT INTO tPlaylistPlaylistMap(rootId,subId)
                  VALUES(?,?)''', (rootId,subId))
			entry_id=self.cursor.lastrowid
			self.db.commit()

		# Catch the exception
		except Exception as e:
		    # Roll back any change if something goes wrong
		    self.db.rollback()
		    entry_id=0
		    raise e
		finally:
		    # Close the db connection
		    self.db.close()
		return entry_id		






def unique(seq):
    seen = set()
    seen_add = seen.add
    return [ x for x in seq if x not in seen and not seen_add(x)]